
{*******************************************************}
{                                                       }
{       4th GUI Library (VCL Edition)                   }
{       Components Registration Unit                    }
{                                                       }
{       Copyright (c) 1996,2003 Sergiy S. Tkachenko     }
{       e-mail: support@4thfebruary.tk                  }
{          Web: www.4thfebruary.tk                      }
{                                                       }
{*******************************************************}

unit Reg4GUI;

{$I FTHVER.INC}

interface

uses
  Classes,
{$IFNDEF DELPHI4_UP}
  DsgnIntf, FthSBEd,
{$ENDIF}
  FthSBar, FthTabs, FthBtns, FthImage, FthHint, FthCtrls;

procedure Register;

implementation

{$IFNDEF DELPHI4_UP}

{TFourthShortcutBarEditor}

type
  TFourthShortcutBarEditor = class(TComponentEditor)
    procedure ExecuteVerb(Index: Integer); override;
    function GetVerb(Index: Integer): string; override;
    function GetVerbCount: Integer; override;
  end;

procedure TFourthShortcutBarEditor.ExecuteVerb(Index: Integer);
begin
  case Index of
    0: if ShowShortcutBarEditor(TFourthShortcutBar(Component)) then
         Designer.Modified;
  end;
end;

function TFourthShortcutBarEditor.GetVerb(Index: Integer): string;
begin
  case Index of
    0: Result := 'Edit...';
  end;
end;

function TFourthShortcutBarEditor.GetVerbCount: Integer;
begin
  Result := 1;
end;

{$ENDIF}

procedure Register;
begin
  RegisterComponents('4th GUI', [
    TFourthShortcutBar,         { fthsbar.pas }
    TFourthTabSet,              { fthtabs.pas }
    TFourthImage,               { fthimage.pas }
    TFourthHintPanel,           { fthhint.pas }
    TFourthStandardButton,      { fthbtns.pas }
    TFourthCaptionLikeButton,   { fthbtns.pas }
    TFourthPanel,               { fthctrls.pas }
    TFourthBevel                { fthctrls.pas }
  ]);
{$IFNDEF DELPHI4_UP}
  RegisterComponentEditor(TFourthShortcutBar, TFourthShortcutBarEditor);
{$ENDIF}
end;

end.

