unit FindUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  TFlatGroupBoxUnit, TFlatCheckBoxUnit, StdCtrls, zTable, DB,
  TFlatButtonUnit, TFlatRadioButtonUnit, zEdit, DBGrids;

type
  TFindF = class(TForm)
    Label_1962: TLabel;
    Label_1963: TLabel;
    SColumnTitle: TLabel;
    FindStr: TEdit;
    BFind_1118: TButton;
    BCancel_1079: TButton;
    BWholeWord_1964: TCheckBox;
    BMatchCase_1965: TCheckBox;
    BExact_2001: TCheckBox;
    GroupBox1: TGroupBox;
    BBegining_2000: TRadioButton;
    BUp_1967: TRadioButton;
    BDown_1968: TRadioButton;
    procedure FindStrChange(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: word;
      Shift: TShiftState);
    procedure FloatKeyPress(Sender: TObject; var Key: char);
    procedure IntegerKeyPress(Sender: TObject; var Key: char);
    procedure BFind_1118Click(Sender: TObject);
    procedure BExact_2001Click(Sender: TObject);
  private
    { Private declarations }
    ZT: TzTable;
  public
    { Public declarations }
    Grid: TDBGrid;
  end;

var
  FindF: TFindF;

implementation
{$R *.DFM}

uses Unit1;

procedure TFindF.FindStrChange(Sender: TObject);
begin
  BFind_1118.Enabled := FindStr.Text <> '';
end;

procedure TFindF.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Action := caFree;
end;

procedure TFindF.FormCreate(Sender: TObject);
begin
  Font.Name := Application.MainForm.Font.Name;
  ZT := Form1.zTable1;
  Grid := Form1.DBGrid1; // connecting to form1 ...
end;

procedure TFindF.FormKeyDown(Sender: TObject; var Key: word;
  Shift: TShiftState);
begin
  if (Key = VK_RETURN) and BFind_1118.Enabled then 
  begin
    BFind_1118Click(nil);
    Close;
    //    ModalResult := mrOk;
  end
  else if key = VK_ESCAPE then Close;
end;

procedure TFindF.FloatKeyPress(Sender: TObject; var Key: char);
begin
  if (Key > ' ') then with FindStr do 
    begin
      if not (Key in [DecimalSeparator, '0'..'9', '-']) then 
      begin
        Key := Chr(0);
        Exit;
      end;
      if Key = DecimalSeparator then 
      begin
        if Pos(DecimalSeparator, Text) > 0 then Key := Chr(0);
      end
      else if Key = '-' then 
      begin
        if (SelStart > 0) or (Pos('-', Text) > 0) then Key := Chr(0);
      end
    end;
end;

procedure TFindF.IntegerKeyPress(Sender: TObject; var Key: char);
begin
  if (Key > ' ') then with FindStr do 
    begin
      if not (Key in ['0'..'9', '-']) then 
      begin
        Key := Chr(0);
        Exit;
      end;
      if Key = '-' then 
      begin
        if (SelStart > 0) or (Pos('-', Text) > 0) then Key := Chr(0);
      end
    end;
end;

procedure TFindF.BFind_1118Click(Sender: TObject);
var 
  i: smallint;
begin
  if BBegining_2000.Checked then i := 0
  else if BDown_1968.Checked then i := 1
  else 
    i := -1;

  ZT.SearchStr(Grid.SelectedField, FindStr.Text, i,
    BWholeWord_1964.Enabled and BWholeWord_1964.Checked,
    BMatchCase_1965.Enabled and BMatchCase_1965.Checked,
    BExact_2001.Enabled and BExact_2001.Checked);
end;

procedure TFindF.BExact_2001Click(Sender: TObject);
begin
  BWholeWord_1964.Enabled := not BExact_2001.Checked;
  BMatchCase_1965.Enabled := not BExact_2001.Checked;
end;

end.
