unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, DB, zTable, ExtCtrls, DBCtrls, Grids, DBGrids,
  ComCtrls, ShellApi, FindUnit;

type
  TForm1 = class(TForm)
    zTable1: TzTable;
    SaveDialog1: TSaveDialog;
    OpenDialog1: TOpenDialog;
    GroupBox1: TGroupBox;
    Button1: TButton;
    Button2: TButton;
    Button4: TButton;
    DBGrid1: TDBGrid;
    DataSource1: TDataSource;
    DBNavigator1: TDBNavigator;
    Button3: TButton;
    StatusBar1: TStatusBar;
    Button7: TButton;
    Button5: TButton;
    Button6: TButton;
    Button8: TButton;
    Button9: TButton;
    Button10: TButton;
    Button11: TButton;
    CheckBox1: TCheckBox;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure zTable1AfterClose(DataSet: TDataSet);
    procedure zTable1AfterOpen(DataSet: TDataSet);
    procedure Button3Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure zTable1UserCountChange(DataSet: TDataSet);
    procedure Button7Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button8Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure Button10Click(Sender: TObject);
    procedure Button11Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation


{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
begin
  if SaveDialog1.Execute then 
  begin
    zTable1.Close;
    zTable1.FieldDefs.Clear;
    zTable1.FieldDefs.Add('IntField', ftInteger);
    zTable1.FieldDefs.Add('StrField', ftString, 20); // string size ...
    zTable1.FieldDefs.Add('BooleanField', ftBoolean);

    //You can do this from DesignMode:
    //can DoubleClick on the component, in shown window
    //call PopUp Menu and click "NewField" ...

    zTable1.TableName := SaveDialog1.FileName;
    if FileExists(zTable1.TableName) then
      DeleteFile(zTable1.TableName);
    zTable1.CreateTable;
    zTable1.Open;
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  SaveDialog1.InitialDir :=
    ExtractFilePath(Application.ExeName);

  OpenDialog1.InitialDir :=
    SaveDialog1.InitialDir;

  randomize;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  if OpenDialog1.Execute then
  begin
    zTable1.Close;
    zTable1.TableName := OpenDialog1.FileName;
    zTable1.Open;
  end;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  zTable1.Close;
  DeleteFile(zTable1.TableName);
end;

procedure TForm1.zTable1AfterClose(DataSet: TDataSet);
begin
  Caption := Application.Title;
end;

procedure TForm1.zTable1AfterOpen(DataSet: TDataSet);
begin
  Caption := Application.Title + ' - ' + extractfilename(zTable1.TableName);
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  zTable1.Close;
  zTable1.Exclusive := True;
  zTable1.Open;
  zTable1.EmptyTable;
  zTable1.Close;
  zTable1.Exclusive := False;
  zTable1.Open;
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
  zTable1.Append;
  zTable1.FieldByName('intField').AsInteger := zTable1.RecordCount + 1;
  zTable1.FieldByName('strField').AsString := 'Appended String';
  zTable1.FieldByName('booleanField').AsBoolean := ((zTable1.RecordCount mod 2) = 0);
  zTable1.Post;
end;

procedure TForm1.Button6Click(Sender: TObject);
begin
  zTable1.Lock;
end;

procedure TForm1.zTable1UserCountChange(DataSet: TDataSet);
begin
  StatusBar1.Panels[1].Text := IntToStr(zTable1.UserCount);
end;

procedure TForm1.Button7Click(Sender: TObject);
begin
  ShellExecute(handle, 'Open', PChar(application.exename), nil, nil, sw_shownormal);
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  zTable1.Close;
  // if not specified, probably you can get AV
  // if database is opened by few applications ...
end;

procedure TForm1.Button8Click(Sender: TObject);
begin
  zTable1.UnLock;
end;

procedure TForm1.Button9Click(Sender: TObject);
begin
  Application.CreateForm(TFindF, FindF);
  FindF.ShowModal;
end;

procedure TForm1.Button10Click(Sender: TObject);
begin
  zTable1.Insert;
  zTable1.FieldByName('intField').AsInteger := zTable1.RecordCount + 1;
  zTable1.FieldByName('strField').AsString := 'Inserted String';
  zTable1.FieldByName('booleanField').AsBoolean := ((zTable1.RecordCount mod 2) = 0);
  zTable1.Post;
end;

procedure TForm1.Button11Click(Sender: TObject);
begin
  zTable1.Sort(zTable1.FieldByName('IntField'));
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
  if Checkbox1.Checked then 
  begin
    zTable1.Filter := 'intField > 5';
    zTable1.Filtered := True;
  end 
  else 
  begin
    zTable1.Filter := '';
    zTable1.Filtered := False;
  end;
end;

procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  zTable1.Close;
end;

end.
